﻿if (typeof rs == 'undefined') var rs = {};
if (typeof rs.layout == 'undefined') rs.layout = {};

rs.layout.menu = {
    constants: {
        showAfter: 200,
        submenuHeight: 0, //высота div'a .sub
        topOffset: 95, //отступ от верха
        height: "",
        padding: 55, //padding для стрелки, закрывающей меню
        closeTimeout: 2000, //milliseconds
        carouselSpeed: 300, //скорость анимации карусели
        carouselItemPadding: 30, //padding елемента карусели. Иначе наезжает
        afterNavDivId: "afterNav" //id дива, который вставляется после #nav
    },
    _isOpening: false,
    initialize: function () {
        rs.layout.menu.initializeFloatMenu();
        rs.layout.menu.initializeMenuEvents();
        rs.layout.menu.initializeCarousel();        
    },
    initializeFloatMenu: function () {
        //Плавающее меню
        var zIndex = 2;
        var menu = $('#nav');
        window.onscroll = function () {
            var scroll = rs.layout.menu.getScrollTop();
            var afterNavDiv = $('#' + rs.layout.menu.constants.afterNavDivId);
            if (scroll >= rs.layout.menu.constants.topOffset) {                
                if (afterNavDiv.length == 0) {//добавляем пустой див вместо дива #nav, чтобы контент не сдвигался, когда меню становится плавающим
                    $('<div id="'+ rs.layout.menu.constants.afterNavDivId + '" style="height:' + menu.height() + 'px"></div>').insertAfter(menu);
                }                
                menu.css('position', 'fixed');
                menu.css('top', 0 + 'px');
            } else if (scroll < rs.layout.menu.constants.topOffset) {                                 
                $('.section-wrap').css('margin-top', 0); //чтобы не оставалась щель, когда страницу с раскрытым меню прокрутили вверх                                   
                menu.css('position', 'static');
                $('#nav .sub').css('z-index', zIndex); //без этого меню становится прозрачным                                
                if (afterNavDiv.length > 0) {
                    afterNavDiv.remove();
                }
            }
            rs.layout.menu.setMenuLeft();
        };
    },
    initializeMenuEvents: function () {
        //Раскрытие/скрытие меню
        $("#nav .menu li a").click(function () {
            var elements = rs.layout.menu.getElements($(this).parent());
            if ($('li.active').length == 0) {
                rs.layout.menu.openMenu(elements);
            }
            else if (elements.current.is('.active')) {
                rs.layout.menu.closeMenu(elements);
            } else {
                rs.layout.menu.selectMenuElement(elements);
            }
            return false;
        });

        //Сворачивание меню
        $("#nav .sub .hide-sub").click(function () {
            var elements = rs.layout.menu.getElements();
            rs.layout.menu.closeMenu(elements);
            return false;
        });

                $("#nav").lazy("mouseleave",
                            function () {
                                if ($("li.active").length != 0) {
                                    var elements = rs.layout.menu.getElements();
                                    rs.layout.menu.closeMenu(elements);
                                }
                            },
                            rs.layout.menu.constants.closeTimeout,
                            "mouseenter");
    },
    getElements: function (current) {
        if (!current)
            current = $('li.active');
        var content = $('.section-wrap');        
        return {
            current: current,
            menu: $("#nav .sub"),
            content: content            
        };
    },
    //Высчитывает высоту для элементов карусели.
    getHeight: function (item) {
        var result = Math.max.apply(null, $('ul', item).map(function () {
            return $(this).height();
        }).get());

        return result + rs.layout.menu.constants.carouselItemPadding;
    },
    initializeCarousel: function () {
        var h = rs.layout.menu.calculateHeight();
        $("#navContainer").rcarousel(
            {
                visible: 1,
                step: 1,
                speed: rs.layout.menu.constants.carouselSpeed,
                width: 700,
                getHeight: rs.layout.menu.getHeight,
                height: 1000,
                start: function () {
                    var carusel = $(this);
                    $('#nav .menu ul li a').each(function (index, elem) {
                        $(elem).bind('click', {
                            page: index,
                            carusel: carusel
                        },
                            function (event) {
                                if (rs.layout.menu.isOpening()) {
                                    event.data.carusel.rcarousel('option', 'speed', 0);
                                    rs.layout.menu.setOpening(false);
                                } else {
                                    event.data.carusel.rcarousel('option', 'speed', rs.layout.menu.constants.carouselSpeed);
                                }
                                $("#navContainer").rcarousel('goToPage', event.data.page);
                                $('.tip').hide();
                                $('.tip:eq(' + event.data.page + ')').fadeIn();
                                event.preventDefault();
                            });
                    });
                    rs.layout.menu.constants.submenuHeight = h + rs.layout.menu.constants.padding;
                    $(".sub-wrap").height(h + rs.layout.menu.constants.carouselItemPadding);
                    $('.sections-container').height(h + rs.layout.menu.constants.carouselItemPadding);
                }
            });
    },
    calculateHeight: function () {
        return Math.max.apply(null, $('#navContainer ul').map(function () {            
            return $(this).height();
        })
                                                        .get());
    },
    openMenu: function (elements) {
        rs.layout.menu.setOpening(true);
        elements.current.addClass('active');
        elements.menu.stop().animate({ 'height': rs.layout.menu.constants.submenuHeight + 'px' }, 'fast');
        var scroll = document.documentElement.scrollTop || document.body.scrollTop;
        if (scroll >= rs.layout.menu.constants.topOffset) {
            elements.content.stop().animate({ 'margin-top': '+=' + rs.layout.menu.constants.submenuHeight + 'px' }, 'fast');
        }
    },
    closeMenu: function (elements) {
        elements.current.removeClass("active");
        elements.menu.stop().animate({ 'height': '0px' }, 'fast');
        var scroll = document.documentElement.scrollTop || document.body.scrollTop;
        if (scroll >= rs.layout.menu.constants.topOffset) {
            var margin = elements.content.margin().top - rs.layout.menu.constants.submenuHeight;
            margin = Math.max(margin, 0);
            elements.content.stop().animate({ 'margin-top': margin + 'px' }, 'fast');
        }
        $('#afterNav').height($("#nav .menu").height()); //меняем размер пустого дива, как размер меню(либо открыто, либо закрыто)
        $(window).trigger("scroll");
    },
    selectMenuElement: function (elements) {
        $("li.active").removeClass("active");
        elements.current.addClass('active');
    },
    getScrollTop: function () {
        return (document.documentElement.scrollTop || document.body.scrollTop);
    },
    getScrollLeft: function () {
        return (document.documentElement.scrollLeft || document.body.scrollLeft);
    },
    setMenuLeft: function () {
        var scrollTop = rs.layout.menu.getScrollTop();
        var navMenuUl = $('#nav .menu ul');
        if (scrollTop < rs.layout.menu.constants.topOffset) {
            navMenuUl.css('width', '');
        };
        
        var scrollLeft = rs.layout.menu.getScrollLeft();
        $('#nav').css('left', -scrollLeft + 'px');
    },
    setOpening: function (value) {
        this._isOpening = value;
    },
    isOpening: function () {
        return this._isOpening;
    }
};

jQuery(document).ready(function () {
    //Menu Initializing
    rs.layout.menu.initialize();
    $(window).resize(function () {
        rs.layout.menu.setMenuLeft();
    });
    rs.layout.menu.setMenuLeft();    
});
