﻿if (typeof rs == 'undefined') var rs = {};
if (typeof rs.layout == 'undefined') rs.layout = {};

rs.layout.socials = {
    FB_CONTROLLER: "Feedback",
    FB_ACTION:"GetFeedbackBlock",
    keys: {
        isShowSocialMedia: "isShowSocialMedia",
        hideAfter: 30000 //30 сек        
    },
    initialize: function () {
        rs.layout.socials.bindHideShowEvents();
        //Скрывает блок соц.ф. через определенный промежуток времени   
        var hideSocialsAfterTime;
        var cookie = rs.cookies.getCookie(rs.layout.socials.keys.isShowSocialMedia);
        if (cookie) {
            var isShow = cookie == 'true';
            if (isShow) {
                rs.layout.socials.showSocialMedia();                
            } else {                
                rs.layout.socials.animateHideButton(".social-media-hidden");
            }
        } else {
            rs.layout.socials.showSocialMedia();
            //Скрывает блок соц.ф. через время hideAfter. Ф-я из плагина Underscore.js. Справка по ф-и http://underscorejs.ru/#debounce       
            //debounce: задаём, что ф-я hideSocialMediaAnimation вызовется через hideAfter
            hideSocialsAfterTime = _.debounce(rs.layout.socials.hideSocialMediaAnimation, rs.layout.socials.keys.hideAfter);
            hideSocialsAfterTime(); //Вызываем hideSocialMediaAnimation. Вызовется через hideAfter.
        }

        //Событие клика по блоку соц.ф
        $(".social-media-wrap").click(function () {
            if (hideSocialsAfterTime) {
                hideSocialsAfterTime(); //Вызываем hideSocialMediaAnimation. Вызовется через hideAfter после последнего вызова.
            }
        });
    },
    //События скрытия/раскрытия блока соц.ф
    bindHideShowEvents: function () {
        //hide
        $(".social-media .hide").click(function () {
            rs.layout.socials.hideSocialMediaAnimation();
            rs.cookies.setCookie(rs.layout.socials.keys.isShowSocialMedia, false, rs.cookies.getExpiresDate(), "/");
            return false;
        });
        //show
        $(".social-media-hidden .hide").click(function () {
            $(".social-media-wrap").animate({ "bottom": "-110px" }, "normal");
            $(".social-media-hidden").fadeOut();
            rs.layout.socials.animateHideButton(".social-media");
            rs.cookies.setCookie(rs.layout.socials.keys.isShowSocialMedia, true, rs.cookies.getExpiresDate(), "/");
            return false;
        });
    },
    //после загрузки страницы плавно показывает кнопку раскрытия соц.ф-й
    animateHideButton: function (className) {
        $(className).delay(500).fadeIn("slow");
        $(".social-media-wrap").animate({ "bottom": "-50px" }, "normal");
    },
    
    //показывает блок соц.ф-й без анимации
    showSocialMedia: function () {
        $(".social-media").show();
        $(".social-media-hidden").hide();
        //rs.layout.socials.animateHideButton(".social-media-hidden");
    },
    //скрывает блок соц.ф-й без анимации
    hideSocialMedia: function () {
        $(".social-media").hide();
        $(".social-media-hidden").show();
        //rs.layout.socials.animateHideButton(".social-media-hidden");
    },
    hideSocialMediaAnimation: function () {
        $(".social-media-wrap").animate({ "bottom": "-110px" }, "normal");
        $(".social-media").fadeOut();
        rs.layout.socials.animateHideButton(".social-media-hidden");
    }
};

jQuery(document).ready(function () {
    //Social Media   
    rs.layout.socials.initialize();
});

$(function () {
    $('#popup.feedback .close').live('click', function () {
        $.unblockUI();
        return false;
    });

    $("#footer .feedback").click(function () {
        $.blockUI({
            message: $("#popup.feedback"),
            css: {
                top: "15%",
                cursor: 'default',
                border: "0",
                left: "0",
                width: "100%"
            },
            overlayCSS: {
                cursor: 'default'
            }
        });
        rs.vacancy.callFeedbackBlock(rs.layout.socials.FB_CONTROLLER, rs.layout.socials.FB_ACTION);
        return false;
    });
});

